com.ihr.xbrl.om.assertions

## Class XBRLValueAssertion

- java.lang.Object
- - com.ihr.xbrl.om.XMLFragment
  - - com.ihr.xbrl.om.exLinks.XLinkElement
    - - com.ihr.xbrl.om.exLinks.XBRLPointerOfARelationship
      - - com.ihr.xbrl.om.exLinks.XBRLResource
        - - com.ihr.xbrl.om.formula.XBRLFormulaResource
          - - com.ihr.xbrl.om.formula.XBRLVariableSetResource
            - - com.ihr.xbrl.om.assertions.XBRLAssertion
              - - com.ihr.xbrl.om.assertions.XBRLValueAssertion

- All Implemented Interfaces:
    HasAdditionalEqualityForReassignation, AssertionEvaluationLocal, EvaluableAssertion, HasAssertionId, StaticAssertionCheck, XBRLRelationshipPoint, XBRLMessageContext, HasFormulaProcessor, HasUncoveredAspectValueResolver, XBRLVariablesHolder, XMLEvaluationContextProvider, Thinable, XBRLValidation, XBRLValueKey, XMLHasParent, java.lang.Cloneable, javax.xml.namespace.NamespaceContext

      public class XBRLValueAssertion
      extends XBRLAssertion
      implements HasAssertionId

  The Class XBRLValueAssertion.
  Author:
    Ignacio

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.ihr.xbrl.om.XBRLValidation

      `XBRLValidation.Direction`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static javax.xml.namespace.QName` | `resourceName` The Constant resourceName.
    `static javax.xml.namespace.QName` | `test` The Constant test.
    `static javax.xml.namespace.QName` | `va_test_expression` Used for the creation of messages.

    - ### Fields inherited from class com.ihr.xbrl.om.formula.XBRLVariableSetResource

      `aspectModel, implicitFiltering`

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XBRLResource

      `nullResource`

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `actuate, ACTUATE, ARC, arcrole, ARCROLE, ETITLE, EXTENDED, from, FROM, href, HREF, label, LABEL, LOCATOR, RESOURCE, role, ROLE, show, SHOW, SIMPLE, title, TITLE, to, TO, TYPE`

    - ### Fields inherited from class com.ihr.xbrl.om.XMLFragment

      `CONCEPT_LABEL, CONCEPT_QNAME, EASY_TO_READ, ELEMENT_LABEL, EMPTYRELATIONSHIPSITERATORINSTANCE, EMPTYXMLFRAGMENTITERATORINSTANCE, FACT_CONCEPT_DATATYPE, FACT_CONCEPT_LABEL, FACT_QNAME, HIDE_COMMON_ACCURACY, idQName, NO_POSITION, OrderComparator, OrderComparator2, PERIOD_TYPE, PERIOD_VALUE, SHORT_TEXT, SOURCE_DOCUMENT, XPATH, XPOINTER`

    - ### Fields inherited from interface com.ihr.xbrl.om.formula.XBRLVariablesHolder

      `MODEL_DIMENSIONAL, MODEL_NON_DIMENSIONAL`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XBRLValueAssertion(XBRLFormulaProcessor proc, XBRLExtendedLink parent, net.sf.saxon.s9api.XdmNode resNode)` Instantiates a new XBRL value assertion.
    `XBRLValueAssertion(XBRLFormulaProcessor proc, XBRLResource other)` Instantiates a new XBRL value assertion.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `collectAssertionVariablenames(java.util.HashSet<javax.xml.namespace.QName> allVars)` Collect assertion variablenames.
    `XBRLAssertionResult[]` | `evaluateAssertionType(XBRLInstance instance)` Evaluate assertion type.
    `net.sf.saxon.s9api.XdmItem` | `getAssertionContextItem()` Gets the assertion context item.
    `java.lang.String` | `getAssertionID()` Returns a text identifying the assertion from the linkbase syntax. this is either the value of the id attribute or the value of the xlink:label on the resource
    `java.util.Collection<? extends XBRLVariableResourceUse>` | `getAssertionMessageVariables()` Gets the assertion message variables.
    `java.lang.String` | `getErrorIdentification()` Returns an string that identifies the assertion when an error is produced.
    `java.lang.String` | `getExpression()` Returns the assertion XPath expression.
    `XBRLResource` | `getResource()` Returns the XBRLResource that contains the definition of the assertion.
    `void` | `staticAssertionCheck()` Static assertion check.

    - ### Methods inherited from class com.ihr.xbrl.om.assertions.XBRLAssertion

      `evaluateAssertion, getEvaluationContext, getToolTipText, resetEvaluationContext, staticCheck`

    - ### Methods inherited from class com.ihr.xbrl.om.formula.XBRLVariableSetResource

      `allDimensions, bindCycle, bindLastEvaluatedVariableValues, bindParameters, bindVariableValue, checkCyclicDependencies, compileFilters, compileFormulaExpression, declareVariables, getAspectModel, getBindableVariableNames, getFilters, getNumberOfVariables, getOptimizer, getUncoveredAspectsSet, getUncoveredAspectValue, getVariableResource, getVariableResourceUses, getVariableUse, getVariableValue, getVariableValue, getXFIImplicitFilterOptimizer, isCovered, isImplicitFilter`

    - ### Methods inherited from class com.ihr.xbrl.om.formula.XBRLFormulaResource

      `getProcessor`

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XBRLResource

      `addChild, clear, equals, generateLocatorToNode, generateNode, getAttributes, getDTSBase, getFriendlyName, getFriendlyName, getParent, getResourceIdentifier, getRoleType, getType, getValidationReport, getValueKey, hashCode, invalidate, invalidate, isComplexType, isOnValidation, isSimpleType, setComplexType, setDTSBase, setId, setParent, setRole, setRoleType, setSimpleType, setValue, validate`

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `getActuate, getArcrole, getFromTxt, getHRef, getLabel, getRole, getShow, getStaticLabel, getSType, getTitle, getToTxt, isRequiredAttribute, isValidAttribute, setActuate, setArcrole, setFrom, setHRef, setLabel, setShow, setSType, setTitle, setTo`

    - ### Methods inherited from class com.ihr.xbrl.om.XMLFragment

      `addAttribute, addFromRelationship, addNamespace, addNamespace, addToRelationship, addXMLChild, changeBase, checkBase, clone, clone, delAttribute, delAttribute, equalXdmValues, evaluateBoolean, evaluateList, evaluateNode, evaluateNumber, evaluateString, generateId, generateNodeNamespacesAndAttributes, generateNodeValue, generatePrefix, getAllAttributes, getAttribute, getAttributeBooleanValue, getAttributeQNameValue, getAttributes, getAttributeStringValue, getAttributeValue, getBase, getBase, getBaseURI, getBooleanValue, getChild, getContainer, getContainerDocumentURI, getDeclaredNamespaces, getDocument, getElements, getElementsHashCode, getFragment, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getGenericLabelText, getId, getLang, getNamespaceURI, getNodeName, getNumberOfAttributes, getNumberOfElements, getNumberOfFromRelationships, getNumberOfToRelationships, getOrGenerateId, getPrefix, getPrefixes, getQNameValue, getRelationshipsBases, getRelationshipsChain, getRelationshipTypes, getStaticContext, getStaticNamespace, getStringValue, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getValue, getXPathExecutable, getXPathNamespaceContext, getXPathToNode, getXPathToRoot, getXPointerElementScheme, getXPointerElementScheme, getXPointerShorthandScheme, getXPointerToNode, isDead, isNamespaceDefined, isXdmDocumentAttached, objEquals, objHashCode, qNameToString, removeAttribute, removeChild, removeChild, removeFromRelationship, removeToRelationship, removeXMLChild, resetElements, resetHash, resolve_equal2, resolveHRef, resolveHRef, s_equal2, s_equal2, s_equal2, setAttributes, setBase, setDocument, setDocumentAndReload, setElements, setLang, setNamespaceContext, setNamespaces, setNode, setNodeName, setParent, setRegenerateNodeIfnotFound, setValue, setVariablesDefined, size, thin, toString, valueEquals, xEqual`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.ihr.xbrl.om.assertions.EvaluableAssertion

      `getLabel`

    - ### Methods inherited from interface com.ihr.xbrl.om.formula.HasFormulaProcessor

      `getProcessor`

    - ### Methods inherited from interface com.ihr.xbrl.om.exLinks.XBRLRelationshipPoint

      `addFromRelationship, addToRelationship, getFromRelationships, getToRelationships, removeFromRelationship, removeToRelationship`

- - ### Field Detail

    - #### test

          public static final javax.xml.namespace.QName test

      The Constant test.

    - #### resourceName

          public static final javax.xml.namespace.QName resourceName

      The Constant resourceName.

    - #### va_test_expression

          public static final javax.xml.namespace.QName va_test_expression

      Used for the creation of messages.

  - ### Constructor Detail

    - #### XBRLValueAssertion

          public XBRLValueAssertion(XBRLFormulaProcessor proc,
                            XBRLResource other)
                             throws XFValidationException

      Instantiates a new XBRL value assertion.
      Parameters:
        `proc` - the proc
        `other` - the other
      Throws:
        `XFValidationException` - the XF validation exception

    - #### XBRLValueAssertion

          public XBRLValueAssertion(XBRLFormulaProcessor proc,
                            XBRLExtendedLink parent,
                            net.sf.saxon.s9api.XdmNode resNode)
                             throws XFValidationException

      Instantiates a new XBRL value assertion.
      Parameters:
        `proc` - the proc
        `parent` - the parent
        `resNode` - the res node
      Throws:
        `XFValidationException` - the XF validation exception

  - ### Method Detail

    - #### evaluateAssertionType

          public XBRLAssertionResult[] evaluateAssertionType(XBRLInstance instance)
                                                      throws XFValidationException

      Description copied from interface: `AssertionEvaluationLocal`
      Evaluate assertion type.
      Specified by:
        `evaluateAssertionType` in interface `AssertionEvaluationLocal`
      Parameters:
        `instance` - the instance
      Returns:
        the XBRL assertion result[]
      Throws:
        `XFValidationException` - the XF validation exception

    - #### getAssertionID

          public java.lang.String getAssertionID()

      Returns a text identifying the assertion from the linkbase syntax. this is either the value of the id attribute or the value of the xlink:label on the resource
      Specified by:
        `getAssertionID` in interface `HasAssertionId`
      Returns:
        the Assertion ID

    - #### staticAssertionCheck

          public void staticAssertionCheck()
                                    throws XFValidationException

      Description copied from interface: `StaticAssertionCheck`
      Static assertion check.
      Specified by:
        `staticAssertionCheck` in interface `StaticAssertionCheck`
      Throws:
        `XFValidationException` - the XF validation exception

    - #### getAssertionMessageVariables

          public java.util.Collection<? extends XBRLVariableResourceUse> getAssertionMessageVariables()

      Description copied from interface: `XBRLMessageContext`
      Gets the assertion message variables.
      Specified by:
        `getAssertionMessageVariables` in interface `XBRLMessageContext`
      Returns:
        the assertion message variables

    - #### getAssertionContextItem

          public net.sf.saxon.s9api.XdmItem getAssertionContextItem()

      Description copied from interface: `XBRLMessageContext`
      Gets the assertion context item.
      Specified by:
        `getAssertionContextItem` in interface `XBRLMessageContext`
      Returns:
        the assertion context item

    - #### collectAssertionVariablenames

          public void collectAssertionVariablenames(java.util.HashSet<javax.xml.namespace.QName> allVars)

      Description copied from interface: `XBRLMessageContext`
      Collect assertion variablenames.
      Specified by:
        `collectAssertionVariablenames` in interface `XBRLMessageContext`
      Parameters:
        `allVars` - the all vars

    - #### getExpression

          public java.lang.String getExpression()

      Description copied from class: `XBRLAssertion`
      Returns the assertion XPath expression.
      Specified by:
        `getExpression` in class `XBRLAssertion`
      Returns:
        String

    - #### getErrorIdentification

          public java.lang.String getErrorIdentification()

      Description copied from interface: `EvaluableAssertion`
      Returns an string that identifies the assertion when an error is produced.
      Specified by:
        `getErrorIdentification` in interface `EvaluableAssertion`
      Returns:
        the error identification

    - #### getResource

          public XBRLResource getResource()

      Description copied from interface: `EvaluableAssertion`
      Returns the XBRLResource that contains the definition of the assertion.
      Specified by:
        `getResource` in interface `EvaluableAssertion`
      Returns:
        the XBRL Resource